use strict;
use Pg;
    my $oConn = Pg::connectdb(
        'host=lins dbname=test user=scott password=tiger');
    die $oConn->errorMessage if($oConn->status != PGRES_CONNECTION_OK);
    $oConn->exec('begin');
    my $oid = $oConn->lo_creat(PGRES_INV_WRITE);
    my $lFd = $oConn->lo_open($oid, PGRES_INV_WRITE);

    open(IN, '<test.png');
    binmode(IN);
    my ($sBuff, $iLen);
    while($iLen = read(IN, $sBuff, 2048)) {
        $oConn->lo_write($lFd, $sBuff, $iLen);
    }
    close IN;
    $oConn->lo_close($lFd);
    $oConn->exec("INSERT INTO stimg VALUES ($oid)");
    die $oConn->errorMessage if($oConn->errorMessage);
    $oConn->exec('end');

use DBI;
    my $hDb = DBI->connect('dbi:Pg:host=lins;dbname=test', 
                'scott', 'tiger', {RaiseError=>1, AutoCommit=>0}) or
            die "CONNECT ERROR $DBI::errstr";
    $hDb->commit;
    my $oId = $hDb->func($hDb->{pg_INV_WRITE}, 'lo_creat');
    my $oFd = $hDb->func($oId, $hDb->{pg_INV_WRITE}, 'lo_open');
    my $hSt = $hDb->prepare('INSERT INTO STIMG VALUES (?);');
    open(IN, '<test.png');
    my($sBuff, $iLen);
    while($iLen = read(IN, $sBuff, 2048)){
        $hDb->func($oFd, $sBuff, $iLen, 'lo_write');
    }
    close(IN);
    $hDb->func($oFd, 'lo_close');
    $hSt->execute($oId);
    $hDb->commit;
    $hDb->disconnect;
