use strict;
use DBI;
my @aConn = ('dbi:Pg:host=lins;dbname=test',
                'scott', 'tiger',);
sub insData($$$) {
    my ($sTitle, $sDate, $sPict) = @_;
    my $hDb = DBI->connect(@aConn,
        {RaiseError=>1, AutoCommit=>0}) or
            die "CONNECT ERROR $DBI::errstr";
    eval {
        my $hSt = $hDb->prepare(
            q/INSERT INTO ALBUM (TITLE, CREDT, PICIMG) VALUES (?, ?, ?)/);
        $hSt->bind_param(3, undef, DBI::SQL_BINARY);
        $hSt->execute($sTitle, $sDate, $sPict);
    };
    my $sRes;
    if($@) {
        $hDb->rollback;
        $sRes = "NG: $@";
    }
    else {
        $hDb->commit;
        $sRes = 'OK:';
    }
    $hDb->disconnect();
    return $sRes;
}
