#!/usr/bin/perl
use strict;
use DBI;
my @aConn = ('dbi:Pg:host=lins;dbname=test', 
                'scott', 'tiger',);
sub getDsp($) {
    my ($sParam) = @_;
    my $hDb = DBI->connect(@aConn, 
        {RaiseError=>1, AutoCommit=>0}) or
            die "CONNECT ERROR $DBI::errstr";       
    my $hSt = $hDb->prepare( 
        q{SELECT TITLE,TO_CHAR(CREDT,'YYYY/MM/DD') 
          FROM ALBUM WHERE TITLE LIKE ?} );
    $hSt->execute($sParam);
    my @aRes;
    while( my @aRes = $hSt->fetchrow_array()) {
        push @aRes, \@aRes;
    };
    $hSt->finish();
    $hDb->disconnect();
    return \@aRes;
}
