#!/usr/bin/perl
use strict;
use DBI;
my @aConn = ('dbi:Pg:host=lins;dbname=test', 
                'scott', 'tiger',);
sub getImg($) {
    my ($sParam) = @_;
    my $hDb = DBI->connect(@aConn, 
        {RaiseError=>1, AutoCommit=>0}) or
            die "CONNECT ERROR $DBI::errstr";       

    $hDb->{LongReadLen}=2_000_000;
    $hDb->{LongTruncOk}=1;
    my $hSt = $hDb->prepare( 
        q/SELECT PICIMG FROM ALBUM WHERE TITLE = ?/ );
    $hSt->execute($sParam);
    my ($sRes) = $hSt->fetchrow_array();
    $hSt->finish();
    $hDb->disconnect();
    return $sRes;
}
